//+------------------------------------------------------------------+ 
//| ARSI.mq4 
//+------------------------------------------------------------------+ 
#property copyright "Alexander Kirilyuk M." 
#property link "" 

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_width1 4
#property indicator_width2 4

//
//
//
//
//

extern int    FastADRsi       = 3;
extern int    SlowADRsi       = 14;
extern bool   LinesVisible    = false;
extern string LinesID         = "rsiadpEMAS";
extern color  LinesUpColor    = MediumSeaGreen;
extern color  LinesDnColor    = Salmon;
extern int    LinesStyle      = STYLE_SOLID;
extern int    LinesWidth      = 0;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "news.wav";


//
//
//
//
//

double upH[];
double dnH[];
double ARSI1[]; 
double ARSI2[]; 
double macdRsi[];
double trend[];
string shortName;

//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,upH);  SetIndexStyle(0,DRAW_HISTOGRAM);
	SetIndexBuffer(1,dnH);  SetIndexStyle(1,DRAW_HISTOGRAM);
	SetIndexBuffer(2,ARSI1); 
	SetIndexBuffer(3,ARSI2); 
	SetIndexBuffer(4,macdRsi);
   SetIndexBuffer(5,trend);
	shortName = LinesID+"2 RSI adaptive EMAs (" + FastADRsi + "," + SlowADRsi+")";
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string find = LinesID+":";
   for (int i=ObjectsTotal()-1; i>= 0; i--)
   {
      string name = ObjectName(i); if (StringFind(name,find)==0) ObjectDelete(name);
   }
   return(0); 
}

//
//
//
//
//

int start() 
{ 
	int counted_bars=IndicatorCounted();
   int i,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
	double sc;
	for(i = limit; i >= 0; i--)
	{
		sc = MathAbs(iRSI(NULL, 0, FastADRsi, PRICE_CLOSE, i)/100.0 - 0.5) * 2.0;
		if( Bars - i <= FastADRsi)
   			ARSI1[i] = Close[i];
		else	ARSI1[i] = ARSI1[i+1] + sc * (Close[i] - ARSI1[i+1]);
		sc = MathAbs(iRSI(NULL, 0, SlowADRsi, PRICE_CLOSE, i)/100.0 - 0.5) * 2.0;
		if( Bars - i <= SlowADRsi)
   			ARSI2[i] = Close[i];
		else	ARSI2[i] = ARSI2[i+1] + sc * (Close[i] - ARSI2[i+1]);
		macdRsi[i]     = ARSI1[i]-ARSI2[i];
		trend[i] = trend[i+1];
		upH[i]   = EMPTY_VALUE;
		dnH[i]   = EMPTY_VALUE;
		if (macdRsi[i] > 0) trend[i] = 1;
		if (macdRsi[i] < 0) trend[i] =-1;
		if (trend[i] == 1) upH[i] = macdRsi[i];
		if (trend[i] ==-1) dnH[i] = macdRsi[i];
		if (LinesVisible)
 	   {
 	      string name = LinesID+":"+Time[i];
 	         ObjectDelete(name);
 	         if (trend[i]!=trend[i+1])
 	         {
 	            color theColor  = LinesUpColor; if (trend[i]==-1) theColor = LinesDnColor;
 	               ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
 	                  ObjectSet(name,OBJPROP_WIDTH,LinesWidth);
 	                  ObjectSet(name,OBJPROP_STYLE,LinesStyle);
 	                  ObjectSet(name,OBJPROP_COLOR,theColor);
 	         }
 	   }  
	}
	
	//
	//
	//
	//
	//
	
	if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," 2 RSI ad EMAS ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," 2 RSI ad EMAS "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      

